### R code from vignette source 'gsc.rnw'

###################################################
### code chunk number 1: gsc.rnw:7-11
###################################################
options(continue=" ")
options(SweaveHooks=list(fig=function()
par(mar=c(4.1, 4.1, 2.6, 1.6), cex=0.7, cex.main=1)))
library (gsc)


###################################################
### code chunk number 2: gsc.rnw:47-48
###################################################
gsc ()


###################################################
### code chunk number 3: gsc.rnw:56-58
###################################################
#increasing
gsc (,"+")


###################################################
### code chunk number 4: gsc.rnw:62-64
###################################################
#convex
gsc (,,"+")


###################################################
### code chunk number 5: gsc.rnw:68-70
###################################################
#convex:increasing
gsc (,"+", "+")


###################################################
### code chunk number 6: gsc.rnw:74-76
###################################################
#increasing-constant-increasing
gsc (,"+0+", knots=c (10, 20) )


###################################################
### code chunk number 7: gsc.rnw:82-84
###################################################
#straight-convex-concave:positive
gsc ("+",,"0+-", knots=c (50, 200) )


###################################################
### code chunk number 8: gsc.rnw:91-92
###################################################
args (gsc_solve)


###################################################
### code chunk number 9: gsc.rnw:105-108
###################################################
n = 100
x = seq (0, 10, length=n)
y = x^2 + 8 * rnorm (n)


###################################################
### code chunk number 10: gsc.rnw:112-113
###################################################
plot (x, y, type="l")


###################################################
### code chunk number 11: gsc.rnw:118-119
###################################################
m = gsc (,"+", "+")


###################################################
### code chunk number 12: gsc.rnw:123-124
###################################################
v = gsc_solve (m, x, y)


###################################################
### code chunk number 13: gsc.rnw:128-130
###################################################
plot (x, y, type="l", main="transformed series in blue")
lines (x, v, col="blue")


###################################################
### code chunk number 14: gsc.rnw:140-144
###################################################
n_raw = 80
x = unique (rnorm (n_raw) )
n = length (x)
x = sort (x)


###################################################
### code chunk number 15: gsc.rnw:148-149
###################################################
p = (1:n) / n


###################################################
### code chunk number 16: gsc.rnw:156-157
###################################################
plot (x, p, type="l")


###################################################
### code chunk number 17: gsc.rnw:162-164
###################################################
m = gsc (,"+",,"+")
v = gsc_solve (m, p, x)


###################################################
### code chunk number 18: gsc.rnw:168-170
###################################################
plot (x, p, type="l")
lines (v, p, col="blue")


###################################################
### code chunk number 19: gsc.rnw:177-185
###################################################
#resample first, series x_ and p_
n_ = 200
x_ = seq (min (v), max (v), length=n_)
p_ = c (1 / n, numeric (n_ - 2), 1)
for (i in 2:(n_ - 1) )
{	k = sum (x_ [i] >= v)
	p_ [i] = k / n + (x_ [i] - v [k]) / (v [k + 1] - v [k]) / n
}


###################################################
### code chunk number 20: gsc.rnw:188-193
###################################################
#differentiate
dx = (x_ [n_] - x_ [1]) / (n_ - 1)
dp = diff (p_)
midpoints = x_ [-n_] + dx / 2
density = dp / dx


###################################################
### code chunk number 21: gsc.rnw:197-198
###################################################
plot (midpoints, density, type="l", main="poor series")


###################################################
### code chunk number 22: gsc.rnw:206-212
###################################################
n = 107
x = seq (-5, 10, length=n)
y = rep (0, n)
y [x < 0] = x [x < 0]^3
y [x > 5] = (x [x > 5] - 5)^3
y = y + 6 * rnorm (n)


###################################################
### code chunk number 23: gsc.rnw:216-217
###################################################
plot (x, y, type="l")


###################################################
### code chunk number 24: gsc.rnw:224-231
###################################################
closest = function (x, k)
{	dist = abs (x - k)
	i = which.min (dist)
	x [i]
}
k1 = closest (x, 0)
k2 = closest (x, 5)


###################################################
### code chunk number 25: gsc.rnw:235-237
###################################################
m = gsc (,"+++", "-0+", knots=c (k1, k2) )
m


###################################################
### code chunk number 26: gsc.rnw:241-242
###################################################
v = gsc_solve (m, x, y)


###################################################
### code chunk number 27: gsc.rnw:246-249
###################################################
plot (x, y, type="l")
lines (x, v, col="blue")
abline (v=c (k1, k2), lty=2)


